'use strict';

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

function _classPrivateFieldGet(receiver, privateMap) {
  var descriptor = privateMap.get(receiver);

  if (!descriptor) {
    throw new TypeError("attempted to get private field on non-instance");
  }

  if (descriptor.get) {
    return descriptor.get.call(receiver);
  }

  return descriptor.value;
}

function _classPrivateFieldSet(receiver, privateMap, value) {
  var descriptor = privateMap.get(receiver);

  if (!descriptor) {
    throw new TypeError("attempted to set private field on non-instance");
  }

  if (descriptor.set) {
    descriptor.set.call(receiver, value);
  } else {
    if (!descriptor.writable) {
      throw new TypeError("attempted to set read only private field");
    }

    descriptor.value = value;
  }

  return value;
}

var BASE_URL = 'https://js-remote-debugger.herokuapp.com/api';

var generateUuid = function generateUuid() {
  return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
    var r = Math.random() * 16 | 0,
        v = c == 'x' ? r : r & 0x3 | 0x8;
    return v.toString(16);
  });
};

var RemoteDebugger = /*#__PURE__*/function () {
  function RemoteDebugger() {
    _classCallCheck(this, RemoteDebugger);

    _appId.set(this, {
      writable: true,
      value: void 0
    });

    _sessionId.set(this, {
      writable: true,
      value: void 0
    });

    _isInitializeFired.set(this, {
      writable: true,
      value: void 0
    });

    _userInfo.set(this, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldSet(this, _appId, '');

    _classPrivateFieldSet(this, _sessionId, '');

    _classPrivateFieldSet(this, _isInitializeFired, false);

    _classPrivateFieldSet(this, _userInfo, '');
  }

  _createClass(RemoteDebugger, [{
    key: "initialize",
    value: function initialize(appId) {
      _classPrivateFieldSet(this, _isInitializeFired, true);

      _classPrivateFieldSet(this, _sessionId, generateUuid());

      _classPrivateFieldSet(this, _appId, appId);

      this.log({
        type: 'INFO',
        data: '',
        label: "SESSION ".concat(_classPrivateFieldGet(this, _sessionId), " STARTED")
      });
    }
  }, {
    key: "setUserInfo",
    value: function setUserInfo(userInfo) {
      _classPrivateFieldSet(this, _userInfo, userInfo);
    }
  }, {
    key: "log",
    value: function log(event, onSuccess, onError) {
      if (!_classPrivateFieldGet(this, _isInitializeFired)) {
        if (onError) {
          onError('REMOTE DEBUGGER: YOU SHOULD RUN INITIALIZE FIRST');
        }
      }

      if (!event) {
        if (onError) {
          onError('REMOTE DEBUGGER: EVENT CONFIGURATION IS EMPTY');
        }
      }

      var eventToSend = _objectSpread2({}, event, {
        userInfo: _classPrivateFieldGet(this, _userInfo),
        sessionId: _classPrivateFieldGet(this, _sessionId)
      });

      if (!eventToSend.type) {
        eventToSend.type = 'REGULAR';
      }

      return fetch("".concat(BASE_URL, "/events"), {
        method: 'POST',
        mode: 'cors',
        headers: {
          'Content-Type': 'application/json',
          'firebase-id': _classPrivateFieldGet(this, _appId)
        },
        body: JSON.stringify(eventToSend)
      }).then(function (res) {
        if (onSuccess) {
          onSuccess(eventToSend);
        }

        return res.json();
      })["catch"](function (err) {
        if (onError) {
          onError(err);
        }

        return console.error('REMOTE DEBUGGER ERROR: PROJECT NOT FOUND. CHECK YOU SETTINGS');
      });
    }
  }]);

  return RemoteDebugger;
}();

var _appId = new WeakMap();

var _sessionId = new WeakMap();

var _isInitializeFired = new WeakMap();

var _userInfo = new WeakMap();

var remoteDebugger = new RemoteDebugger();

module.exports = remoteDebugger;
